####################################################
# Blah Software Code      |    Software Version: 2 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2003 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/Routines.lng");

if($yabbconver) { $pwcry = 'ya'; }
	else { $pwcry = "B~"; }

# May ONLY be removed if you have paid for e-blah (unless you have prior, written permission), see the e-blah website for more information.
$copyright = qq~Powered by <a href="http://www.eblah.com" target="_new">e-blah</a> $versioncr  2001-2003~;

sub header {
	if($hdone) { return; } # Headers have already been completed, do not run them through again ...
	print "Content-type: text/html\n\n";
	$hdone = 1;

	$date_time = get_date(time);
	$kday = $day; $kmon = $month;
	if($username eq 'Guest') { $displayuser = qq~$rtxt[1], <b>$rtxt[2]</b>; $rtxt[3] <a href="$surl,v=login">$rtxt[4]</a> $rtxt[44] <a href="$surl,v=register">$rtxt[5]</a>.~; &ShowGuest; }
	elsif($settings[1] eq '') { $displayuser = qq~$rtxt[1] <b>$username</b>, $rtxt[7]~; }
		else { $pmcnt = 0; $new = 0;
			fopen(FILE,"$members/$username.pm");
			while(<FILE>) {
				($med,$t,$t,$t,$t,$t,$n) = split(/\|/,$_);
				if($med == 1) {
					if($n) { ++$new; }
					++$pmcnt;
				}
			}
			fclose(FILE);
			$displayuser = "$rtxt[1] $rtxt[9] <b>$settings[1]</b>";
			if(!$pmdisable) { $displayuser .= qq~, $rtxt[10] $pmcnt ($new $rtxt[11]) <a href="$surl,v=pm" title="$rtxt[12]">$rtxt[13]</a>.~; }
			if($settings[4] eq 'Administrator' && ($maintance || $lockout)) {
				if($maintance) { $on = $rtxt[14]; }
				if($maintance && $lockout) { $on .= $rtxt[15]; }
				if($lockout) { $on .= $rtxt[16]; }
				$displayuser .= "<br><b> $rtxt[17] $on </b>";
			}
		}
	if($helpdesk) { $help = qq~$msp <a href="$helpdesk">$img{'help'}</a>~; }

	$menubar = qq~<a href="$surl">$img{'home'}</a>$help $msp<a href="$surl,v=cal">$img{'cal'}</a> $msp<a href="$surl,v=search">$img{'search'}</a>~;
	if($settings[4] eq 'Administrator') { $menubar .= qq~ $msp<a href="$surl,v=admin">$img{'admin'}</a>~; }
	if($username ne 'Guest') { $menubar .= qq~ $msp<a href="$surl,v=profile">$img{'profile'}</a> $msp<a href="$surl,v=notify">$img{'notify'}</a> $msp<a href="$surl,v=login,p=3">$img{'logout'}</a>~; }
		else { $menubar .= qq~ $msp<a href="$surl,v=register">$img{'register'}</a> $msp<a href="$surl,v=login">$img{'login'}</a>~; }

	$template = $template || "$root/template.html"; # Get the template to use
	fopen(FILE,"$template") or print "$template not found!";
	@temp = <FILE>;
	fclose(FILE);
	chomp @temp;
	foreach(@temp) {
		$_ =~ s/<blah v="\$(.+?)">/${$1}/gsi;
		if($_ =~ /<blah main>/) { $sfoot = 1; next; }
		elsif(!$sfoot) { $header .= $_; }
			else { $footer .= $_; }
	}

	print $header;
	if(!$gdisable) { print $guestlogin; }
}

sub footer {
	if($uextlog) { &ExtClose; }

	if($settings[1] ne '' && $logactive) {
		fopen(FILE,"$members/$username.dat"); # Get data into memory again to avoid errors
		@temp = <FILE>;
		fclose(FILE);
		chomp @temp;

		$temp[28] = time;
		fopen(FILE,"+>$members/$username.dat");
		for($q = 0; $q < $usersetcount; $q++) { print FILE "$temp[$q]\n"; }
		fclose(FILE);
	}

	if($benchmark) { # Output the CPU time, and load time if requested ...
		$t1 = new Benchmark;
		$td = timediff($t1,$t0);
		$load = timestr($td);
		if($benchmark == 1) { print qq~<font size="1" face="verdana">$load</font>~; }
			else {
				# 1 wallclock secs ( 0.13 usr + 0.02 sys = 0.14 CPU)
				$load =~ s~([0-9]*?) wallclock secs \( (.*?) usr \+ (.*?) sys = (.*?) CPU\)~~gsi;
				print <<"EOT";
<br>
<table align="center" width="400" cellspacing="1" cellpadding="4" bgcolor="$color{'border'}">
 <tr>
  <td bgcolor="$color{'win'}" align="center"><font size="1">[ <b>Time Taken:</b> $1 | <b>CPU Consumption:</b> $4 ($2 + $3) ]</font></td>
 </tr>
</table>
EOT
			}
	}

	print $footer;
}

sub AL {
	my(@activelog,$al,$luser,$ltime,$mytime,$math,@maxlog);
	if($username eq 'Guest') { $buser = $ENV{'REMOTE_ADDR'}; } else { $buser = $username; }
	fopen(FILE,"$prefs/Active.txt");
	@activelog = <FILE>;
	fclose(FILE);
	$logmax = @activelog;
	$mytime = time;
	fopen(FILE,"$prefs/MaxLog.txt");
	@maxlog = <FILE>;
	fclose(FILE);
	chomp @maxlog;
	if($maxlog[0] < $logmax) {
		fopen(FILE,">$prefs/MaxLog.txt");
		print FILE "$logmax\n$mytime";
		fclose(FILE);
	}
	fopen(FILE,"+>$prefs/Active.txt");
	print FILE "$buser|$mytime|$settings[18]|$URL{'v'}|$URL{'b'}|$URL{'m'}\n";
	foreach $al (@activelog) {
		chomp $al;
		($luser, $ltime) = split(/\|/,$al);
		$math = $mytime-$ltime;
		if($math < 900 && lc($luser) ne lc($buser)) { print FILE "$al\n"; }
		$activemembers{$luser} = 1;  # Keep user in memory for checking online status quickly
	}
	fclose(FILE);
	if($uextlog) { $ExtLog[7] = $logmax; }
}

sub error {
	my($ecode,$elog) = @_;
	my($ttime,$etype,$icon);
	$error = Format($ecode);
	$message = $error;
	&BC;
	$error = $message;
	if($error =~ /-admin-/ || $error =~ /-register-/) { &SpecialErrors; }
	$icon = 'ban';
	if($elog) {
		$icon = 'warning';
		$ewhat = "$rtxt[18] "; $esig = qq~<br><br><font size="1"><b>$rtxt[19]</b></font>~;
		if($kelog) {
			chomp $!; chomp $error; chomp $errorurl;
			$errorurl = "Blah.pl?$ENV{'QUERY_STRING'}";
			$ttime = time;
			$specify = $! || '?';
			fopen(FILE,"+>>$prefs/ELog.txt");
			print FILE "$error|$specify|$ttime|$username|$errorurl\n";
			fclose(FILE);
		}
	}
	$error =~ s/$code|$messages|$members|$prefs|$boards/./gsi;  # Security: Change full paths to local
	$ewhat .= $rtxt[41];
	if($root ne '.') { $error =~ s/$root/./gsi; }
	$title = $ewhat;
	$date_time = get_date(time);
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="600" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/$icon.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2"><br>$error</font>$esig<br><br></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center"><font size="2"><b><a href="javascript:history.go(-1)"> $gtxt{'22'}</a></b></font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub redirect {
	($url2) = $_[0];
	if($url eq '') { $url = $scripturl; }
	if($url2) { $url = $url2; }
	if($redirectfix) {
		$title = $rtxt[42];
		&header;
		print <<"EOT";
<meta http-equiv="refresh" content="0;URL=$url">
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="280">
 <tr>
  <td bgcolor="$color{'win'}" align="center"><font size="2"><b>$rtxt[42]</b><br><br><font size="1">(<a href="$url">$rtxt[43]</a>)</font></font></td>
 </tr>
</table>
EOT
		&footer;
	} else { print "Location: $url\n\n"; }
	exit;
}

sub date_dis {
	my($unbld) = $_[0];
	my($ttdate,$tttime,$day1);
	if(!$settings[17]) { $settings[17] = $datedis; }
	if(!$settings[22]) { $settings[22] = $timedis; }
	$day1 = $day;

	$day = &datest($day);

	if($settings[17] == 1) { $ttdate = "$days[$week], $months[$month] $day, $year"; }
	elsif($settings[17] == 2) { $ttdate = "$day1 $months[$month] $year"; }
	elsif($settings[17] == 3) { ++$month; $ttdate = "$month.$day1.$year"; }
		else { $ttdate = "$months[$month] $day, $year"; }
	if($settings[22] > 1) {
		if($hour < 10) { $hour = "0$hour"; }
		if($ampm eq 'pm' && $hour != 12) { $hour = $hour+12; }
		if($hour == 12 && $ampm eq 'am') { $hour = "00"; }
		if($sec < 10) { $sec = "0$sec"; }
		if($settings[22] == 2) { $tttime = "$hour:$min"; }
			else { $tttime = "$hour:$min:$sec"; }
	} elsif($settings[22] == 1) {
		if($sec < 10) { $sec = "0$sec"; }
		$tttime = "$hour\:$min\:$sec$ampm";
	} else { $tttime = "$hour:$min$ampm"; }
	if(!$unbld && $btod && $kday == $day && $kmon == $month) { $ttdate = "<b>$rtxt[20]</b>"; }
	$ddis = "$ttdate $rtxt[21] $tttime";
}

sub datest {
	my($day) = $_[0];
	if($day < 20 && $day > 10) { $day .= 'th'; }
	elsif($day%10 == 1) { $day .= 'st'; }
	elsif($day%10 == 2) { $day .= 'nd'; }
	elsif($day%10 == 3) { $day .= 'rd'; }
		else { $day .= 'th'; }
	return($day);
}

sub get_date {
	my($date,$unbld) = @_;
	if($date eq '') { $date = time; }
	($sec,$min,$hour,$day,$month,$year,$week,$ydays,$dst) = gmtime($date+(3600*($settings[15]+$settings[31]+$gtoff)));
	$ampm = "am";
	$year = 1900 + $year;
	if($min < 10) { $min = "0$min"; }
	$thour = $hour;
	if($hour == 12) { $ampm = "pm"; }
	if($hour == 0) { $hour = 12; }
	if($hour >= 13) {
		$hour = ($hour - 12);
		$ampm = "pm";
	}

	&date_dis($unbld);
	return($ddis);
}

sub fopen {
	my($fh,$fn,$bkups) = @_;

	open($fh,$fn);
	if($uflock) {
		flock($fh,$fopen);
		seek($fh,0,0);
	} else { return; }
}

sub fclose {
	my($fh) = $_[0];
	if($uflock == 1) { flock($fh,$fclose); } else { 1; }
	close($fh);
}

sub ClickLog {
	my($clt,$lgtm,$maxtime,$maxed,$final,$day,$month,$year,@read,$nlog);
	if($uextlog) {
		($t,$t,$t,$day,$month,$year) = localtime(time);
		$ExtLogT = $day.$month.$year;
		++$ExtLog[0];
	}
	if($eclick != 1) { return; }
	$clt = time;
	$ref = $ENV{'HTTP_REFERER'} =~ /$realurl\/Blah.pl/ ? '' : $ENV{'HTTP_REFERER'};

	fopen(RAW,"+<$prefs/ClickLog.txt");
	@read = <RAW>;
	seek(RAW,0,0);
	truncate(RAW,0);
	print RAW "$clt|$ENV{'REMOTE_ADDR'}|$ref|$ENV{'QUERY_STRING'}|$ENV{'HTTP_USER_AGENT'}\n";
	foreach (@read) {
		chomp;
		($lgtm) = split(/\|/,$_);
		$maxtime = ($logcnt*60);
		$maxx = ($clt-$maxtime);
		$maxed = ($lgtm-$maxx);
		if($maxed > 0) { print RAW "$_\n"; } else { last; }
	}
	fclose(RAW);
}

sub BCSmileys {
	$message =~ s~\Q::)\E~<img src="$simages/roll.gif" border="0">~gi;
	$message =~ s~\Q:)\E~<img src="$simages/smiley.gif" border="0">~gi;
	$message =~ s~\Q:-)\E~<img src="$simages/smiley.gif" border="0">~gi;
	$message =~ s~\Q:D\E~<img src="$simages/lol.gif" border="0">~gi;
	$message =~ s~\Q:-D\E~<img src="$simages/lol.gif" border="0">~gi;
	$message =~ s~\Q:B\E~<img src="$simages/blush.gif" border="0">~gi;
	$message =~ s~\Q??)\E~<img src="$simages/huh.gif" border="0">~gi;
	$message =~ s~\Q:'(\E~<img src="$simages/cry.gif" border="0">~gi;
	$message =~ s~\Q:X\E~<img src="$simages/lipsx.gif" border="0">~gi;
	$message =~ s~\Q:o\E~<img src="$simages/shock.gif" border="0">~gi;
	$message =~ s~\Q:K)\E~<img src="$simages/kiss.gif" border="0">~gi;
	$message =~ s~(\A|\W);D~$1<img src="$simages/grin.gif" border="0">~gi;
	$message =~ s~\Q;-D\E~<img src="$simages/grin.gif" border="0">~gi;
	$message =~ s~\Q8)\E~<img src="$simages/cool.gif" border="0">~gi;
	$message =~ s~\Q:P\E~<img src="$simages/tongue.gif" border="0">~gi;
	$message =~ s~\Q\&gt;:(\E~<img src="$simages/angry.gif" border="0">~gi;
	$message =~ s~\Q:-/\E~<img src="$simages/undecided.gif" border="0">~gi;
	$message =~ s~\Q:(\E~<img src="$simages/sad.gif" border="0">~gi;
	$message =~ s~\Q:-(\E~<img src="$simages/sad.gif" border="0">~gi;
	$message =~ s~(\A|\W)\Q;)\E~$1<img src="$simages/wink.gif" border="0">~gi;
	$message =~ s~(\A|\W)\Q;-)\E~$1<img src="$simages/wink.gif" border="0">~gi;
	if($upbc) {
		fopen(FILE,"$prefs/smiley.txt");
		@smiley = <FILE>;
		fclose(FILE);
		chomp @smiley;
		foreach (@smiley) {
			($smile,$slink) = split(/\|/,$_);
			$message =~ s~\Q$smile\E~<img src="$simages/$slink">~g;
		}
	}
}

sub Quote {
	my($qdate,$qmessage,$repaste,$qname);
	if($2) {
		$qdate = get_date($3);
		$userset{$1}->[1] = '';
		loaduser($1);
		if($userset{$1}->[1] ne '') { $qname = qq~<a href="$scripturl,v=profile,a=view,u=$1">$userset{$1}->[1]</a>~; }
			else { $qname = $1; }
		$repaste = qq~<tr><td bgcolor="$color{'win2'}"><font size=1><i>$rtxt[22] $qname, $rtxt[23] $qdate $rtxt[21] <a href="$2" title="$rtxt[25]">$rtxt[26]</a>.</i></font></td></tr>~;
		$qmessage = $4;
	} else { $qmessage = $1; }
	$format = qq~<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="95%" align="center"><tr><td bgcolor="$color{'win2'}"><font size="1"><b> $rtxt[27]</b></font></td></tr><tr><td bgcolor="$color{'win'}"><font size=1>$qmessage</font></td></tr>$repaste</table>~;
	return($format);
}

sub SizedURL {
	$url = $_[1];
	if(length($url) > 31) { $url = substr($url,0,21).'.....'.substr($url,length($url)-10); }
	return(qq~$_[0]<a href="$_[1]" target="_blank">$url</a>~);
}

sub Code {
	if($BCLoad == 0) { return; }

	%translation = (
		';' => '&#059',
		'(' => '&#040;',
		')' => '&#041;',
		'-' => '&#045;',
		'/' => '&#047;',
		':' => '&#058',
		'?' => '&#063;',
		'[' => '&#091;',
		'\\' => '&#092;',
		']' => '&#093;',
		'<' => '&lt;',
		'>' => '&gt;',
		'.' => '&#046;',
	);
	$code = $1;
	$code =~ s/&lt;/</g;
	$code =~ s/&gt;/>/g;
	$code =~ s/&amp;/&/g;

	$code =~ s/([\:<>\;\(\)\-\/\?\[\]\\\.])/$translation{$1}/sgi;
	$code =~ s/&lt;br&gt;/<br>/gsi;
	return(qq~<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="95%" align="center"><tr><td bgcolor="$color{'win2'}"><font size="1"><b> Code</b></font></td></tr><tr><td bgcolor="$color{'win'}"><font size="1" face="Courier New">$code</font></td></tr></table>~);
}

sub BC {
	if($html && $nosmile < 2) {
		if($htmls[0] ne '') {
			foreach(@htmls) {
				$close = $open = 0;
				while($message =~ s~\&lt;$_(.*?)\&gt;~<$_$1>~) { ++$open; }
				while($message =~ s~\&lt;/$_(.*?)\&gt;~</$_$1>~) { ++$close; }
				while($open > $close) { $message .= "</$_>"; ++$close; } # Close open tags (security)
			}
		} else { $message =~ s~\&lt;(.*?)\&gt;~<$1>~gsi; }
	}
	$message =~ s~\[code\](.*?)\[/code\]~&Code~esgi;

	$message =~ s~\[quote by=(.+?) link=(.+?) date=(.+?)\](.+?)\[/quote\]~&Quote~gsie;
	$message =~ s~\[quote\](.+?)\[/quote\]~&Quote~gsie;

	if($al) {
		$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%,.]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~SizedURL($1,$2)~eisg;
		$message =~ s~([^\"\=\[\]/\:\.(\://\w+)]|[\n\b]|\A)\\*(www\.[^\.][\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%\,]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~SizedURL($1,"http://$2")~eisg;
	}
	if($BCSmile && ($nosmile != 1 && $nosmile != 3)) { &BCSmileys; }

	if(!$BCLoad) { return; }
	$message =~ s~\[s\](.*?)\[/s\]~<s>$1</s>~gsi;
	$message =~ s~\[b\](.*?)\[/b\]~<b>$1</b>~gsi;
	$message =~ s~\[i\](.*?)\[/i\]~<i>$1</i>~gsi;
	$message =~ s~\[u\](.*?)\[/u\]~<u>$1</u>~gsi;
	$message =~ s~\[size=([1-9][^\s\n<>]*?)\](.*?)\[/size\]~<font size="$1">$2</font>~gsi;

	$message =~ s~\[img\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$1://$2" border="0">~gsi;
	$message =~ s~\[img width=([1-9][^\s]*?) height=([1-9][^\s]*?)\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$3://$4" width="$1" height="$2" border="0">~gsi;

	$message =~ s~\[url=(http|ftp|mms|https)://(.[^\s\n<>]+?)\](.+?)\[/url\]~<a href="$1://$2" title="$2" target="_new">$3</a>~gsi;
	$message =~ s~\[url=www\.(.[^\s\n<>]+?)\](.+?)\[/url\]~<a href="http://www.$1" title="www.$1" target="_new">$2</a>~gsi;
	$message =~ s~\[url\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/url\]~SizedURL('',"$1://$2")~egsi;
	$message =~ s~\[url\]www\.(.[^\s\n<>]+?)\[/url\]~SizedURL('',"http://www.$1")~egsi;

	$message =~ s~\[flash width=([0-9]*?) height=([0-9]*?) url=(http|ftp|mms|https)://(.[^\s\n<>]+?)\]~<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="$1" height="$2"><param name="movie" value="$3://$4"><param name="play" value="true"><param name="loop" value="true"><param name="quality" value="high"><embed src="$3://$4" width="$1" height="$2" play="true" loop="true" quality="high"></embed></object>~gsi;

	$message =~ s~\[pre\](.+?)\[/pre\]~<pre>$1</pre>~gsi;
	if($message =~ /\[list(.*?)\](.*?)\[\/list\]/) {
		$message =~ s~\[list\](.+?)\[/list\]~<ul>$1</ul>~gsi;
		$message =~ s~\[list=([a-zA-Z|1]+?)\](.+?)\[/list\]~<ol type="$1">$2</ol>~gsi;
		$message =~ s~\[\*\]~<li>~gsi;
	}

	$message =~ s~\[left\](.+?)\[/left\]~<div align="left">$1</div>~gsi;
	$message =~ s~\[right\](.+?)\[/right\]~<div align="right">$1</div>~gsi;
	$message =~ s~\[center\](.+?)\[/center\]~<center>$1</center>~gsi;
	$message =~ s~\[face=(.+?)\](.+?)\[/face\]~<font face="$1">$2</font>~gsi;
	$message =~ s~\[color=(.+?)\](.+?)\[/color\]~<font color="$1">$2</font>~gsi;
	$message =~ s~\[hr\]~<hr size="1" width="100%" color="$color{'border'}">~gsi;
	$message =~ s~\[sub\](.+?)\[/sub\]~<sub>$1</sub>~gsi;
	$message =~ s~\[sup\](.+?)\[/sup\]~<sup>$1</sup>~gsi;
	$message =~ s~\[mail\](.+?)\[/mail\]~<a href="mailto:$1">$1</a>~gsi;
	$message =~ s~\[mail=(.+?)\](.+?)\[/mail\]~<a href="mailto:$1">$2</a>~gsi;

	if($message =~ /\[table\](.+?)\[\/table\]/) {
		$message =~ s~\[table\](.+?)\[\/table\]~<table>$1</table>~sgi;
		while($message =~ s~<table>(.*?)\[tr\](.*?)\[/tr\](.*?)</table>~<table>$1<tr>$2</tr>$3</table>~sgi) { } # Circulate until rows are done.
		while($message =~ s~<table>(.*?)<tr>(.*?)\[td\](.*?)\[/td\](.*?)</tr>(.*?)</table>~<table>$1<tr>$2<td>$3</td>$4</tr>$5</table>~sig) { } # Circulate until cols are done.
	}

	$message = CensorList($message);
}

sub smail {
	my($subject,$message,$wholemessage,$tothis);
	my($to,$subject,$message,$from) = @_;
	if(!$to || !$subject || !$message) { return; }
	if($to !~ /\A([0-9A-Za-z\._\-]{1,})@([0-9A-Za-z\._\-]{1,})+\.([0-9A-Za-z\._\-]{1,})+\Z/) { return; }

	$message =~ s/\cM//g;
	$message =~ s/\n/<br>/gsi;
	$message =~ s/  / /gsi;
	$message =~ s/&lt;br&gt;/<br>/gsi;
	$message =~ s/<br>/<br>\n/gsi;
	$message =~ s/bgcolor="(.+?)"/bgcolor="#FFFFFF"/gsi;

	$wholemessage = <<"EOT";
<html>
<body bgcolor="#FFFFFF">
<font face="Verdana,Arial" color="#000000" size="2">$message</font>
</body>
</html>
EOT
	if($from eq '') { $from = $eadmin; }
	if($mailuse == 1) {
		open(MAIL,"| $smaill -t");
		print MAIL "MIME-Version: 1.0\n";
		print MAIL "Content-Type: text/html; charset=\"iso-8859-1\"\n";
		print MAIL "Content-Transfer-Encoding: 7bit\n";
		print MAIL "X-Forum-System: e-blah, $version, copyright 2001-2002\n";
		print MAIL "X-Username: $username\n";
		print MAIL "X-Sent-From-IP: $ENV{'REMOTE_ADDR'}\n";
		print MAIL "To: $to\n";
		print MAIL "From: \"$from\" <$eadmin>\n";
		print MAIL "Reply-To: $eadmin\n";
		print MAIL "Subject: $subject\n\n";
		print MAIL "$wholemessage";
		print MAIL "\n\n";
		close(MAIL);
	} elsif($mailuse == 2) {
		eval q{
			use Net::SMTP;
			my $smtp = Net::SMTP->new($mailhost);
			$smtp->mail($eadmin);
			$smtp->to($to);
			$smtp->data();
			$smtp->datasend("MIME-Version: 1.0\n");
			$smtp->datasend("Content-Type: text/html; charset=ISO-8859-1\n");
			$smtp->datasend("Content-Transfer-Encoding: 7bit\n");
			$smtp->datasend("X-Forum-System: e-blah, $version, copyright 2001-2002\n"); # For Verification
			$smtp->datasend("X-Username: $username\n");                                 # For Verification
			$smtp->datasend("X-Sent-From: $ENV{'REMOTE_ADDR'}\n");                      # For Verification
			$smtp->datasend("To: $to\n");
			$smtp->datasend("From: $from <$eadmin>\n");
			$smtp->datasend("Reply-To: $eadmin\n");
			$smtp->datasend("Subject: $subject\n\n");
			$smtp->datasend("$wholemessage");
			$smtp->datasend("\n");
			$smtp->dataend();
			$smtp->quit;
		};
	}

	# The following will be removed in the Final, this is for debugging perpouses ONLY (localhost).
	# fopen(FILE,"+>$root/MailLog.html");
	# print FILE $wholemessage;
	# fclose(FILE);

	return;
}

sub Registry { $regid = "0-0-0"; }

sub ExtClose { # Close extensive log ..
	my($rtxtlog,$save,$u);
	$rtxtlog = time;
	($t,$t,$t,$day,$month,$year) = localtime(time);
	$save = $day.$month.$year;
	fopen(WRITEEXT,"+<$prefs/BHits/$save.txt");
	@ExtensiveLogs = <WRITEEXT>;
	chomp @ExtensiveLogs;
	if($ExtensiveLogs[0] eq '') {
		fclose(WRITEEXT);
		fopen(WRITEEXT,"+>$prefs/BHits/$save.txt");
	}
	seek(WRITEEXT,0,0);
	truncate(WRITEEXT,0);
	for($u = 0; $u < @ExtensiveLogs; $u++) {
		if($ExtensiveLogs[$u] eq '') { $ExtensiveLogs[$u] = 0; }
		if($u != 7) { $PLog[$u] = ($ExtLog[$u]+$ExtensiveLogs[$u]) || 0; }
	}
	if($ExtensiveLogs[7] < $ExtLog[7]) { $PLog[7] = $ExtLog[7]; } else { $PLog[7] = $ExtensiveLogs[7]; }
	print WRITEEXT "$PLog[0]\n$PLog[1]\n$PLog[2]\n$PLog[3]\n$PLog[4]\n$PLog[5]\n$rtxtlog\n$PLog[7]";
	fclose(WRITEEXT);
	@ExtLog = '';
}

sub Mark {
	if($username eq 'Guest') { &error("$rtxt[28]-register-"); }
	if($URL{'l'} eq 'bindex') { $l = "AllBoards"; }
	if($URL{'l'} eq 'bdis') { $l = "AllRead_$URL{'b'}"; }
	$time = time;
	fopen(FILE,"$members/$username.log");
	@log = <FILE>;
	fclose(FILE);
	chomp @log;
	fopen(FILE,"+>$members/$username.log");
	print FILE "$l|$time\n";
	foreach(@log) {
		($data) = split(/\|/,$_);
		if($data ne $l) { print FILE "$_\n"; }
	}
	fclose(FILE);
	&redirect;
}

sub MakeComma {
	$ctobe = $_[0];
	if(!$nocomma) { return($ctobe); }
	if(!$ctobe) { return(0); }
	while($ctobe =~ s/^([-+]?\d+)(\d{3})/$1$nocomma$2/) {}
	return($ctobe);
}

sub SpecialErrors {
	if($error =~ /-admin-/) {
		$error =~ s/-admin-//;
	} elsif($error =~ /-register-/) {
		$error =~ s/-register-//;
		$reg = 1;
	}
	for($x = 1; $x < 3; ++$x) {
		$tryuser = $Blah{"$cooknme\Logout$x"};
		if($tryuser) {
			loaduser($tryuser);
			if($userset{$tryuser}->[4] eq 'Administrator') { $adminerror .= qq~<a href="$scripturl,v=profile,a=view,u=$tryuser">$userset{$tryuser}->[1]</a><br>~; }
			if($userset{$tryuser}->[1] ne '') { $addreg .= qq~<a href="$scripturl,v=login,u=$tryuser">$rtxt[29] $userset{$tryuser}->[1]</a><br>~; }
		}
	}
	$adminerror =~ s/<br>\Z//;
	$addreg =~ s/<br>\Z//;
	if($adminerror && !$reg) { $error .= qq~<br><br><font size="1"><b>$rtxt[30]:</b><br>$adminerror</font>~; }
	if($reg) {
		if($addreg) { $addreg = qq~<br><br><b>$rtxt[30]:</b><br>$addreg~; }
		$error .= qq~<br><br><font size="1"><b>$rtxt[32]:</b><br><a href="$scripturl,v=register">$rtxt[33]</a>.<br><a href="$scripturl,v=login">$rtxt[34]</a>.$addreg</font>~;
	}
}

sub ShowGuest {
	$guestlogin = <<"EOT";
<table cellpadding="1" cellspacing="1">
 <tr><form action="$scripturl,v=login,p=2" method="POST">
  <td align="right"><font size="1"><b>$rtxt[35] - </b></font></td>
  <td align="right"><font size="1"><b>$rtxt[36]:</b></font></td>
  <td><input type=text name=username size=20></td>
  <td align="right"><font size="1"><b>$rtxt[37]:</b></font></td>
  <td><input type="password" name="password" size="20"><input type="hidden" name="days" value="forever"> <input type=submit value="$rtxt[38]"></td>
 </form></tr>
</table><br>
EOT
}

sub calage {
	($bday,$fq) = @_;
	($t,$t,$t,$td,$tm,$ty) = localtime(time);
	($m,$d,$y) = split("/",$bday);
	if(length($y) == 4) { $y = substr($y,2,4); }
	$age = ($ty-$y)-1;
	if($tm+1 >= $m && $td >= $d) { ++$age; }
	if($fq) { return($age); }
	if(!$bday) { $age = $rtxt[39]; }
		else { --$m; $age = qq~$age<br><font size="1"><a href="$scripturl,v=cal,m=$m">$rtxt[40]</a></font>~; }
	return($age);
}

sub CheckDays {
	($qmon) = $_[0];
	$number = (int($qyear/4)*4);
	if($qmon eq 0 || $qmon eq 2 || $qmon eq 4 || $qmon eq 6 || $qmon eq 7 || $qmon eq 9 || $qmon eq 11) { $days = 31; }
	elsif($qmon eq 3 || $qmon eq 5 || $qmon eq 8 || $qmon eq 10) { $days = 30; }
	elsif($qmon eq 1) { if($qyear == $number) { $days = 29; } else { $days = 28; } }
	return($days);
}

sub Highlight {
	$_[0] =~ s/<br>/<br>\n/gsi;
	@smallm = split(/\s/,$_[0]);
	$_[0] = '';

	foreach(@smallm) {
		if($_ !~ /[ht|f]tp/ && $_ =~ /<(.*?)>/) {
			foreach $hl (@lights) {
				if($hl eq '') { next; }
				$_ =~ s~(\Q$hl\E)~<font color="black" style="background-color:yellow"><b>$1</b></font>~isg;
			}
		}
		$_[0] .= $_.' ';
	}
}
1;