####################################################
# Blah Software Code      |    Software Version: 2 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2003 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/Stats.lng");

sub Stats {
	if(!$uextlog) { &error($statstxt[1]); }
	fopen(FILE,"$members/LastMem.txt");
	@lastmem = <FILE>;
	fclose(FILE);
	chomp @lastmem;
	loaduser($lastmem[0]);

	if($eclick) {
		$clicklog = 0;
		fopen(FILE,"$prefs/ClickLog.txt");
		@clicklog = <FILE>;
		fclose(FILE);
		chomp @clicklog;
		$clicklogc = @clicklog;
		if($logcnt > 59) { $logcnt = sprintf("%.0f",($logcnt/60))." $gtxt{'3'}"; }
			else { $logcnt = "$logcnt $gtxt{'2'}"; }
	}

	fopen(FILE,"$prefs/MaxLog.txt");
	@maxlogged = <FILE>;
	fclose(FILE);
	chomp @maxlogged;
	$maxtime = get_date($maxlogged[1]);

	$active = 0;
	fopen(FILE,"$prefs/Active.txt");
	while(<FILE>) { ++$active; }
	fclose(FILE);

	$title = $statstxt[2];
	&header;
	&BoardStats;

	fopen(FILE,"$members/List.txt");
	@memlist = <FILE>;
	fclose(FILE);
	chomp @memlist;
	$maxpostcnt = 0;
	foreach(@memlist) {
		loaduser($_);
		push(@maxmem,"$userset{$_}->[3]|$_");
		push(@newmembers,"$userset{$_}->[14]|$_");
	}
	@maxmem = sort{$b <=> $a} @maxmem;
	@newmembers = sort{$b <=> $a} @newmembers;

	# Find average member per day
	($old) = split(/\|/,$newmembers[$lastmem[1]-1]);
	$memperday = sprintf("%.4f",$lastmem[1]/((time-$old)/86400));

	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="98%" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="7"><font size=2><b><img src="$images/clicklog_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="7"><font size=2><b> $statstxt[3]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="7">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td width="50%"><font size="2"><b><img src="$images/profile_sm.gif"> $statstxt[4]</b></font></td>
     <td width="50%"><font size="2"><b><img src="$images/open_thread.gif"> $statstxt[5]</b></font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="7" valign="top">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td width="50%" valign="top">
      <table cellpadding="3" cellspacing="0" width="100%">
       <tr>
        <td><font size="2"><b>$statstxt[6]:</b></font></td>
        <td align="right"><font size="2">$lastmem[1]</font></td>
       </tr><tr>
        <td><font size="2"><b>$statstxt[7]:</b></font></td>
        <td align="right"><font size="2"><a href="$scripturl,v=profile,a=view,u=$lastmem[0]">$userset{$lastmem[0]}->[1]</a></font></td>
       </tr><tr>
        <td><font size="2"><b>$statstxt[8]:</b></font></td>
        <td align="right"><font size="2">$active</font></td>
       </tr><tr>
        <td valign="top"><font size="2"><b>$statstxt[9]:</b></font></td>
        <td align="right" valign="top"><font size="2">$maxtime</font><br><font size="1">($maxlogged[0] $gtxt{'4'})</font></td>
       </tr><tr>
        <td valign="top"><font size="2"><b>$statstxt[29]:</b></font></td>
        <td align="right" valign="top"><font size="2">~ $memperday</font></td>
       </tr>
      </table>
     </td>
     <td width="50%">
      <table cellpadding="2" cellspacing="0" width="100%">
EOT
	if($eclick) {
		foreach(@clicklog) {
			($logtime,$ipaddy,$ref,$page,$info) = split(/\|/,$_);
			$f1 = 1;
			if(@ipaddys) { foreach(@ipaddys) { if($_ eq $ipaddy) { $f1 = 0; last; } } }
			if($f1) { push(@ipaddys,$ipaddy); ++$ipcnt; }
		}
		$clicklogc = MakeComma($clicklogc);
		print <<"EOT";
       <tr>
        <td valign="top"><font size="2"><b>$statstxt[10] $logcnt:</b></font></td>
        <td align=right><font size="2">$clicklogc</font><br><font size=1>($ipcnt $gtxt{'5'})</font></td>
       </tr>
EOT
	}
	$threads = MakeComma($threads);
	$message = MakeComma($message);
	print <<"EOT";
       <tr>
        <td valign="top"><font size="2"><b>$gtxt{'6'}:</b></font></td>
        <td align="right"><font size="2">$catcnt</font></td>
       </tr><tr>
        <td valign="top"><font size="2"><b>$gtxt{'7'}:</b></font></td>
        <td align="right"><font size="2">$bdscnt</font></td>
       </tr><tr>
        <td valign="top"><font size="2"><b>$gtxt{'8'}:</b></font></td>
        <td align="right"><font size="2">$threads</font></td>
       </tr><tr>
        <td valign="top"><font size="2"><b>$gtxt{'9'}:</b></font></td>
        <td align="right"><font size="2">$message</font></td>
       </tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="7"><font size=2><b> $statstxt[11]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="7">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td width="50%"><font size="2"><b><img src="$images/lamp.gif"> $statstxt[12]</b></font></td>
     <td width="50%"><font size="2"><b><img src="$images/profile_sm.gif"> $statstxt[28]</b></font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="7" valign="top">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
EOT
	&GMS;
	$team{'Administrator'} = 1;
	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		$team = '';
		($posts,$member) = split(/\|/,$maxmem[$g]);
		$posts = MakeComma($posts);
		if($member eq '') { next; }
		if($team{$userset{$member}->[4]}) { $team = qq~ <img src="$images/team.gif" alt="$gtxt{'29'}"> ~; }
		$topmems .= qq~<b>$c.</b>$team <a href="$surl,v=profile,a=view,u=$member">$userset{$member}->[1]</a> <font size="1">($posts $gtxt{'10'})</font><br>~;
		++$c;
	}
	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		$team = '';
		($regged,$member) = split(/\|/,$newmembers[$g]);
		$regged = get_date($regged);
		if($member eq '') { next; }
		if($team{$userset{$member}->[4]}) { $team = qq~ <img src="$images/team.gif" alt="$gtxt{'29'}"> ~; }
		$regnew .= qq~<b>$c.</b>$team <a href="$surl,v=profile,a=view,u=$member">$userset{$member}->[1]</a> ($regged)<br>~;
		++$c;
	}

	print <<"EOT";
     <td valign="top" width="50%"><font size="1">$topmems</font></td>
     <td valign="top" width="50%"><font size="1">$regnew</font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="7">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td width="50%"><font size="2"><b><img src="$images/hotthread.gif"> $statstxt[13]</b></font></td>
     <td width="50%"><font size="2"><b><img src="$images/veryhotthread.gif"> $statstxt[14] ($gtxt{'12'})</b></font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="7" valign="top">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
EOT
	foreach $use (@boardbase) {
		($board) = split('/',$use);
		fopen(FILE,"$boards/$board.msg");
		while(<FILE>) {
			chomp $_;
			($id,$msub,$t,$t,$replies) = split(/\|/,$_);
			push(@mdata,"$replies|$msub|$id|$board");
		}
		fclose(FILE);
	}
	@mdata = sort{$b <=> $a} @mdata;

	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		($replies,$msub,$id,$bdat) = split(/\|/,$mdata[$g]);
		$replies = MakeComma($replies);
		if($msub) { $toptops .= qq~<b>$c.</b> <a href="$surl,v=display,m=$id,b=$bdat,s=$replies">$msub</a> <font size="1">($replies $gtxt{'12'})</font><br>~; }
		++$c;
	}
	if(!$toptops) { $toptops = $statstxt[15]; }
	@tbds = sort{$b <=> $a} @tbds;

	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		($mcnt,$boardnm,$bid) = split(/\|/,$tbds[$g]);
		$mcnt = MakeComma($mcnt);
		if($boardnm) { $topboards .= qq~<b>$c.</b> <a href="$surl,v=mindex,b=$bid">$boardnm</a> <font size="1">($mcnt $gtxt{'11'})</font><br>~; }
		++$c;
	}
	print <<"EOT";
     <td valign="top" width="50%"><font size="1">$topboards</font></td>
     <td valign="top" width="50%" colspan="2"><font size="1">$toptops</font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="7"><font size="2"><b> $statstxt[16] </font><font size="1">($statstxt[17])</b></font></td>
 </tr><tr>
EOT
	($t,$t,$t,$day,$month,$year) = localtime(time);
	$save = $day.$month.$year;

	$found = 0;
	for($i = 0; $i < 7; ++$i) {
		fopen(FILE,"$prefs/BHits/$save.txt");
		@log = <FILE>;
		fclose(FILE);
		chomp @log;
		if(!$log[0]) {
			++$found;
			if($found > 100) {
				print qq~  <td bgcolor="$color{'win2'}" align="center" width="14%"><font size="1"><b>* $gtxt{'13'} *</b></font></td>~;
				push(@list,'|');
			} else { --$i; }
			if($day == 1) { --$month; $day = CheckDays($month)+1; }
			$save = --$day.$month.$year;
			next;
		}
		($t,$t,$t,$dayz,$umon,$yr) = localtime($log[6]);
		$dayz = &datest($dayz);
		$yearz = $yr+1900;

		print qq~  <td bgcolor="$color{'win2'}" align="center" width="14%"><font size="1"><b>$months[$umon] $dayz, $yearz</b></font></td>~;
		push(@list,"$log[0]|$log[1]|$log[2]|$log[3]|$log[4]|$log[5]|$log[7]");
		if($day == 1) { --$month; $day = CheckDays($month)+1; }
		$save = --$day.$month.$year;
		++$found;
	}
	print " </tr><tr>";
	foreach(@list) {
		($clicks,$threads,$replies,$members,$newatt,$attdown,$moston) = split(/\|/,$_);
		if($clicks > $mclicks) { $mclicks = $clicks; }
		if($threads > $mthreads) { $mthreads = $threads; }
		if($replies > $mreplies) { $mreplies = $replies; }
		if($members > $mmembers) { $mmembers = $members; }
		if($newatt > $mnewatt) { $mnewatt = $newatt; }
		if($attdown > $mattdown) { $mattdown = $attdown; }
		if($moston > $mmoston) { $mmoston = $moston; }
	}

	@mtxt = ($statstxt[21],$statstxt[22],$statstxt[23],$statstxt[24],$statstxt[25],$statstxt[26],$statstxt[27]);

	for($z = 0; $z < 7; ++$z) {
		($clicks,$threads,$replies,$members,$newatt,$attdown,$moston) = split(/\|/,$list[$z]);
		if($clicks eq '') {
			print qq~  <td bgcolor="$color{'win'}" width="14%" valign="top"><font size="1">$gtxt{'13'}</font></td>\n~;
			next;
		}

		if($clicks == $mclicks) { $clicks = '<b><u>'.MakeComma($clicks).'</u></b>'; }
			else { $clicks = MakeComma($clicks); }
		if($threads == $mthreads) { $threads = '<b><u>'.MakeComma($threads).'</u></b>'; }
			else { $threads = MakeComma($threads); }
		if($replies == $mreplies) { $replies = '<b><u>'.MakeComma($replies).'</u></b>'; }
			else { $replies = MakeComma($replies); }
		if($members == $mmembers) { $members = '<b><u>'.MakeComma($members).'</u></b>'; }
			else { $members = MakeComma($members); }
		if($newatt == $mnewatt) { $newatt = '<b><u>'.MakeComma($newatt).'</u></b>'; }
			else { $newatt = MakeComma($newatt); }
		if($attdown == $mattdown) { $attdown = '<b><u>'.MakeComma($attdown).'</u></b>'; }
			else { $attdown = MakeComma($attdown); }
		if($moston == $mmoston) { $moston = '<b><u>'.MakeComma($moston).'</u></b>'; }
			else { $moston = MakeComma($moston); }

		print <<"EOT";
  <td bgcolor="$color{'win'}" width="14%">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td align="right"><font size="1"><b>$mtxt[0]:</b></font></td>
     <td><font size="1">$clicks</font></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$mtxt[1]:</b></font></td>
     <td><font size="1">$threads</font></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$mtxt[2]:</b></font></td>
     <td><font size="1">$replies</font></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$mtxt[3]:</b></font></td>
     <td><font size="1">$members</font></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$mtxt[4]:</b></font></td>
     <td><font size="1">$moston</font></td>
    </tr>
EOT
		if($uallow) {
			print <<"EOT";
    <tr>
     <td colspan="2" align="center"><font size="1"><hr size="1" color="$color{'border'}"><b><u>$statstxt[18]</u></b></font></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$statstxt[19]:</b></font></td>
     <td><font size="1">$newatt</font></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$gtxt{'14'}:</b></font></td>
     <td><font size="1">$newatt</font></td>
    </tr>
EOT
		}
		print "   </table>\n  </td>\n";
	}
	opendir(DIR,"$prefs/BHits/");
	@hits = readdir(DIR);
	closedir(DIR);
	foreach(@hits) {
		if($_ eq '.' || $_ eq '..' || $_ eq '.txt') { next; }
		fopen(FILE,"$prefs/BHits/$_");
		@hitsL = <FILE>;
		fclose(FILE);
		chomp @hitsL;
		if($maxh[0] < $hitsL[0]) { $max[0] = $hitsL[6]; $maxh[0] = $hitsL[0]; }
		if($maxh[1] < $hitsL[1]) { $max[1] = $hitsL[6]; $maxh[1] = $hitsL[1]; }
		if($maxh[2] < $hitsL[2]) { $max[2] = $hitsL[6]; $maxh[2] = $hitsL[2]; }
		if($maxh[3] < $hitsL[3]) { $max[3] = $hitsL[6]; $maxh[3] = $hitsL[3]; }
		if($maxh[4] < $hitsL[7]) { $max[4] = $hitsL[6]; $maxh[4] = $hitsL[7]; }
		if($maxh[5] < $hitsL[5]) { $max[5] = $hitsL[6]; $maxh[5] = $hitsL[5]; }
		if($maxh[6] < $hitsL[4]) { $max[6] = $hitsL[6]; $maxh[6] = $hitsL[4]; }
	}
	for($i = 0; $i < 6; ++$i) { $maxh[$i] = MakeComma($maxh[$i]); }

	print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" colspan="7"><font size="2"><b> $statstxt[20]</b></font></td>
 </tr><tr>
EOT
	for($x = 0; $x < 7; ++$x) {
		($t,$t,$t,$dayz,$umon) = localtime($max[$x]);
		if(!$max[$x]) { ($t,$t,$t,$dayz,$umon,$yr) = localtime($max[0]); }
		$dayz = &datest($dayz);
		$yearz = $yr+1900;
		print qq~<td bgcolor="$color{'win2'}" align="center" width="14%"><font size="1"><b>$months[$umon] $dayz, $yearz</b></font></td>\n~;
	}
	print " </tr><tr>\n";
	for($x = 0; $x < 7; ++$x) {
		if(!$maxh[$x]) { $maxh[$x] = '0'; }
		print qq~<td bgcolor="$color{'win'}" align="right" width="14%"><font size="1"><b>$mtxt[$x]:</b> $maxh[$x]</font></td>\n~;
	}
	print <<"EOT";
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub StatsDate {
	my($date) = $_[0];
	($t,$t,$t,$day,$month,$year) = localtime($date);
	$years = 1900 + $year;
	my $ddis = "$months[$month] $day, $years";
}

sub BoardStats {
	foreach(@boardbase) {
		($board,$t,$t,$bname) = split("/",$_);
		fopen(FILE,"$boards/$board.ino");
		@ino = <FILE>;
		fclose(FILE);
		if(!$ino[1]) { $ino[1] = 0; }
		push(@tbds,"$ino[1]|$bname|$board");
		chomp @ino;
		$threads = $threads+$ino[0];
		$message = $message+$ino[1];
	}
	$catcnt = @catbase;
	$bdscnt = @boardbase;
}
1;
